
package jp.catsin.bijinClockWidget;
 
import java.io.FileInputStream;
import java.io.InputStream;

import jp.catsin.bijinClockWidget.R;

import android.app.Service;
import android.appwidget.AppWidgetManager;
import android.appwidget.AppWidgetProvider;
import android.content.BroadcastReceiver;
import android.content.ComponentName;
import android.content.Context;
import android.content.Intent;
import android.content.IntentFilter;
import android.graphics.Bitmap;
import android.graphics.BitmapFactory;
import android.graphics.Canvas;
import android.graphics.Paint;
import android.graphics.BitmapFactory.Options;
import android.os.Environment;
import android.os.IBinder;
import android.text.format.Time;
//import android.util.Log;
import android.widget.RemoteViews;
 
public class bijinClockWidget extends AppWidgetProvider {
	final	static	int	Xsize			= 294;
	final	static	int	Ysize			= 220;
	
	static	String		lastNo			= "";
	static	Context 	myContext		= null;
	static	int			lastId			= 0;

	
    final static String TAG = "bijinClockWidget"; 
    
//    private Intent runningService; 
//    private boolean initStarted; 
     
    @Override
    public void onUpdate(Context context, AppWidgetManager appWidgetManager,
        int[] appWidgetIds) {
        context.startService(new Intent(context, UpdateService.class));
		lastNo	= "";
		
		update(context);
    }

/*    public void onEnabled(Context context)  
    { 
        if(!initStarted) 
        { 
            runningService = new Intent(context, UpdateService.class); 
            context.startService(runningService); 
             
            Log.d(TAG, "Service Started"); 
             
			lastNo	= "";
			
			update(context);
             
            initStarted = true; 
        } 
    } 
     
    public void onDisabled(Context context)  
    { 
        if(initStarted) 
        { 
            context.stopService(runningService); 
             
            Log.d(TAG, "Service Stopped"); 
        } 
    } 
*/     
    public static class UpdateService extends Service { 
        @Override 
        public void onStart(Intent intent, int startId) { 
            registerReceiver(mClockInfoReceiver, new IntentFilter(Intent.ACTION_TIME_TICK)); 
            registerReceiver(mClockInfoReceiver, new IntentFilter(Intent.ACTION_TIMEZONE_CHANGED)); 
        } 

        private BroadcastReceiver mClockInfoReceiver = new BroadcastReceiver() {  
            @Override  
            public void onReceive(Context context, Intent intent) {
            	String action = intent.getAction();  
                if (Intent.ACTION_TIME_TICK.equals(action)||
                	Intent.ACTION_TIMEZONE_CHANGED.equals(action)) {  
                    
                	update(context);
                }
            }  
       };  
         
        @Override 
        public IBinder onBind(Intent intent) { 
            // We don't need to bind to this service 
            return null; 
        } 
    } 

    public	static void	update(Context context){
		//	ݎ̎擾
		Time today = new Time();
		today.setToNow();
		
		String	no	= today.format("%H%M");
		
		if( lastNo.equals(no)==false ){
//			Log.v("catsin", lastNo +":"+no);
			lastNo	= no;

			//	EBWFbgւ̃nh擾
			RemoteViews updateViews = buildUpdate(context);
         
			if( updateViews!=null ){
				// ʂɉo
				ComponentName		thisWidget = new ComponentName(context, bijinClockWidget.class);
				AppWidgetManager	manager = AppWidgetManager.getInstance(context);
				manager.updateAppWidget( thisWidget, updateViews );
			}
			updateViews = null;
		}
	}
	
	public static RemoteViews buildUpdate(Context context) {

		RemoteViews updateViews = new RemoteViews(context.getPackageName(), R.layout.main);
		
		if( updateViews!=null ){
			//	ݎ̎擾
			Time today = new Time();
			today.setToNow();
		
			String	no	= today.format("%H%M");
			
			//	bitmapt@C̓ǂݍ
			String	bitmapFileDir		= String.format("%s/bijinClock/cache/",Environment.getExternalStorageDirectory());
			String	bitmapFileName		= String.format("%s.jpg", no);
			String	bitmapFileFullPath	= String.format("%s%s",bitmapFileDir, bitmapFileName);
//			updateViews.setTextViewText(R.id.word_title, bitmapFileFullPath);

			Bitmap drwBmp = null;
			try {
				drwBmp = loadImage( bitmapFileFullPath, Xsize, Ysize);
			} catch (Exception e) {
				drwBmp	= null;
			}
			
			if( drwBmp==null ){
				//	t@CANZXłȂꍇ͎̂ݕ\
				drwBmp		= Bitmap.createBitmap( Xsize, Ysize, Bitmap.Config.RGB_565 );
				Canvas	canvas	= new Canvas( drwBmp );
				Paint	paint	= new Paint();
				paint.setColor(0xffffffff);
				paint.setTextSize(26);
				canvas.drawText("Not found bitmap file.", 10, 40, paint);

				paint.setTextSize(32);
				String	timeText	= today.format("%H:%M");
				canvas.drawText(timeText, 10, 80, paint);
				
				paint.setTextSize(16);
				canvas.drawText("Set bitmap file->", 10, 120, paint);
				canvas.drawText(bitmapFileDir, 20, 140, paint);
				canvas	= null;
				paint	= null;
			}

			//	bitmap̕\
			if( drwBmp!=null ){
				if( updateViews!=null ){
					updateViews.setImageViewBitmap(R.id.img, drwBmp);
				}
				drwBmp	= null;
			}
			today				= null;
			bitmapFileDir		= null;
			bitmapFileName		= null;
			bitmapFileFullPath	= null;
		}
		return updateViews;
	}
	//---------------------------------------------------------------
    //	wURL̃rbg}bv_E[h
    public static Bitmap loadImage( String filename, int Xsize, int YSize) throws Exception{
//		Log.v("catsin:start", filename);

		Bitmap	drw		= null;
    	Options	bm_opt	= null;
            
    	//	摜TCY̎擾
    	InputStream imgis = new FileInputStream(filename);        	
    	bm_opt	= new Options();
    	bm_opt.inJustDecodeBounds = true; 
    	Bitmap	bitmap = BitmapFactory.decodeStream( imgis, null, bm_opt ); 
    	imgis.close(); 
			
    	int	bitmapXsize	= bm_opt.outWidth;
    	int	bitmapYsize	= bm_opt.outHeight;

//		Log.v("catsin:mid", filename);
    	bm_opt	= null;
    	imgis	= null;
			
    	//	Xgr[̃TCYÔߕKvȃTCY߂Ă
    	int	listviewXsize	= Xsize;
    	int	listviewYsize	= YSize;

    	//	k
    	int	zoomx = (int) Math.floor((double)bitmapXsize / listviewXsize); 
    	int	zoomy = (int) Math.floor((double)bitmapYsize / listviewYsize); 
   			
    	//	wTCYŃrbg}bv_E[h
    	bm_opt	= new Options();
    	bm_opt.inJustDecodeBounds = false; 
    	bm_opt.inSampleSize = Math.min(zoomx, zoomy);  
   			
    	InputStream in = new FileInputStream(filename);  
    	drw = BitmapFactory.decodeStream( in, null, bm_opt ); 
    	in.close();

		//	TCY
		Bitmap	resizeBitmap	= Bitmap.createScaledBitmap( drw, Xsize, YSize, true );
		
    	bm_opt	= null;
    	in		= null;
    	drw		= null;

//		Log.v("catsin:end", filename);
        return( resizeBitmap );
    }
}
 